//写在开头：
//1. 教程的代码和文字说明都写在.js文件中
//2. js文件中的说明文字只能用注释的方式出现
//3. 注释的方式：单行用//表示开始写注释，多行用/*和 */表示注释掉开头和结尾，中间是注释且可以换行【P10专门讲注释】
//4. 我在写这些js代码的行文习惯：
//4.1,根据老师的课程分节，来命名js文件名，
//4.2 js文件内部，使用/*标题*/的样式写标题，
//4.3.1 console.log打印内容如果少，就在代码行末尾使用//表示后面是打印结果
//4.3.2 部分小节的console.log的打印结果使用/* */来限定区域,
//4.3.3 部分章节使用X下面的样式：
    //outputs：
    //打印内容
    //end
//4.4 使用/** */作为小节的结束标记，有时候小节内知识点很多，为了代码更清晰，也会作为知识点的结尾
//4.5 特别说明，老师在讲解的时候，一个知识点用一个例子说明，后续进一步讲下一个知识点，会在例子上做更改
//如果我在笔记里只保留最终的代码，后面再回头复习，可能就不知道原来的知识点的例子是什么样子的。
//所以，需要的时候，我会每个知识点准备新的一份代码，把上个知识点的代码复制一份到下一个知识点。
//通过去掉/*标题 */的尾巴*/，可以让单个知识点变成注释或者可运行代码状态。方便以后复习时查看运行状态结果。【具体用法在P26-函数-额外】
//上面说的是大部分的情形，个别小节可能不是这样的。暂时没有精力去挨个纠正，先发出来，能利用多少用多少。

/*P1-课程简介*/
//课程是2020年最新的课程，VH：不是当前最新的课程
//课程面向JS初学者，不要求有HTML和CSS基础。
//面向：想系统学习JS，学校课程不够全面的同学，有基础的前端工程师对基础知识查漏补缺
//课程从JS基础语法开始，了解如何编写JS程序，后来再慢慢深入各项语法，
//包括最新的ES6,ES7的新特点【背景是2020年】
//学完这门课，就掌握了前端工程师最基本的编程技能。
//每个知识点尽量保持在5分钟左右，方便大家能随时抽出时间来学习

/*P2-简介-为什么要学JS*/
//JS在Node.js出现之后，还有随着ECMAScript更新的加快，
//JS可以开发多端的应用程序，于是成为全家桶式的语言
//利用React，vue,Angular可以开发工程化，大规模的应用程序
//利用React Native还能开发跨平台的移动端应用程序
//使用Electron可以开发跨平台的桌面端应用程序
//通过Node.js可以开发后端的应用程序
//目前，Googel推出TensorFlow的JS版本，所以还能开发机器学习的项目

//在学习完JS和相关框架之后，我们就可以应聘前端工程师的岗位
//前端工程师，是基于React，Vue,Angular这些基于JS的前端库而分离出来的新兴职业
//之前是一个工程师，需要把前端和后端都写好，分离之后，前后端只需专注于一端，提高开发的效率

//看准网的数据，web前端工程师的平均工资在2万元左右，基本没有在1万以下的
//所以说，大家只要把基础掌握得牢固，然后框架也使用得熟练之后，找到一个薪资可观的工作，也是比较容易的

/*P3-简介-什么是JS*/
//JS是一门脚本语言
//遵从ECMAScript规范，由于很早之前制定ECMAScript规范的委员会一直不太活跃，所以过去很长一段时间，JS只能运行在浏览器中，
//而自从ES2015之后，JS增加了很多特性，让它成为了一个比较全面的开发语言，可以应用于各端的开发
//JS分为两种，客户端的和服务端的。客户端的JS由浏览器负责运行，
//服务器端的JS利用Chrome浏览器的V8引擎脱离浏览器，可以运行在操作系统层面，可以与操作系统打交道，这种服务端的运行环境就叫Node.js
//使用Node.js,我们可以开发基于服务端就是后端的应用程序
//客户端的和服务端的JS的语法基本上是一样的。
//这门课程就是教大家在客户端编写应用程序

