/*P11-操作符*/

//对数据进行操作：赋值，比较，数学计算等

//赋值，之前已经了解，等于号
var x = 10;
var y= x;

console.log(x,y,10,200)//10 10,使用,分隔可以无限参数，打印时显示用空格分隔

/* P12-一元操作符 */
//只能作用于一个操作数，
// 1.-，定义一个负数
// 2.+是一元的时候，表示正数，或者把字符串形式的转换成数字类型，和作为二元的时候不一样，表示拼接，把数字转成字符串然后拼接
// 3.++，数字自身加1，放在操作数前面表示+1后返回，放在操作数后面表示先返回再加1

//一元操作符-
console.clear();//浏览器中可以清除之前的打印结果，显示已清除控制台,但是hbuilder中无效，仅显示console.clear
var negativeNum= -5;
console.log(negativeNum);//-5

//一元操作符+
var strNum= +'3';
console.log(strNum, typeof strNum);//3 "number",浏览器的打印number带引号，hbuilder为3 number，无引号

//一元操作符++
var num=8
console.log(num++);//8;放在后面，先返回8，然后背地里默默再加1，不让你知道，内卷
console.log(num);//9;实际上它默默的已经是9了！

console.log(++num);//10;放在前面，9+1，然后返回10
console.log(num);//10;返回已经是10的num

//一元操作符--
console.log(num--);//10;原理同++
console.log(num);//9;

console.log(--num);//8;
console.log(num);//8;


/*P13-算数操作符*/
//类似于数学课
console.clear();//浏览器中可以清除之前的打印结果，但是hbuilder中无效，仅显示console.clear
console.log('1+5=',1+5);//1+5= 6
console.log('5-1=',5-1);//5-1= 4
console.log('3*9=',3*9);//3*9= 27
console.log('7/2=',7/2);//7/2= 3.5
console.log('7%2=',7%2);//7%2= 1,取模
console.log('4**2=',4**2);//4**2= 16,幂运算

/*P14-比较操作符*/
//基本和数学课一样
//大于，小于，大于等于，小于等于，等于等于，三个等于，不等于，不等于等于
console.clear();
console.log('1>5',1>5);//false
console.log('1>=5',1>=5);//false
console.log('5>=5',5>=5);//true

console.log('5==5',5==5);//true
console.log('5=="5"',5=="5");//true
console.log('5==="5"',5==="5");//false
console.log('5===5',5===5);//false

console.log('undefined==null',undefined==null);//true
console.log('undefined===null',undefined===null);//false

/*P15-逻辑运算符*/
//逻辑运算符有3个：与或非
//与&&，或||，非!
//false，0，''，null，undefined均可转成false假
//运算结果和数学上是一样的，

console.clear();

console.log('true && true',true && true);//true
console.log('true && false',true && false);//false

console.log('true || false',true || false);//true

console.log('!true',!true);//false
//表达式：能计算出结果的一串代码

//特性1，与号前面的值或者表达式，结果为true的话，会继续去执行后面，判断是否为true
//前端开发里，满足某个条件，才显示某个组件的话，前面这个true的位置可以换成这个条件，右边换成要显示的组件
console.log("true &&'hello'",true &&'hello');//hello
console.log("4 &&'hello'",4 &&'hello');//hello,4代表true
console.log("!! 0",!!0);//false,这里双！的作用在最下面是返回表达式根本代表的true或false，这里0上面也说过是false，
console.log("4 && 0",4 && 0);//0，虽然0是false，但是这里只要&&前是true或true的表达式，就会返回后面的值，不管是真或假。


//或也是如此，如果第一个值是false，接着就去执行第二个值，判断是否为true
//适合给一个变量一个默认值，如下，default代表一个默认值。
//和上面的&&对应，这里是||前是false时，返回后面的值
console.log("false || 'default'",false || 'default')//default【这是个字符串】
var a = null;
b = a ||5;//5虽然是表达式，为真，但不会返回true或者false，而是把表达式返回，赋值给b
console.log(b)//5，表达式返回，就是5，不是true或者false

//与和或，短路特性
//与，第一个操作数是false，不会计算第二个操作数
//或，第一个操作数是true，不会计算第二个操作数
console.log("false && 'not printed'",false && 'not printed');//false
console.log("true || 'not printed'",true || 'not printed'); //true，第一个操作数返回，true
console.log("4 || 'not printed'",4 || 'not printed'); //4，代表真值，所以第一个操作数返回，4
console.log("4+1 || 'not printed'",4+1 || 'not printed'); //5，代表真值，所以第一个操作数返回，5

//如果想要true或者false，使用非!，返回本来代表的true或者false
console.log(4);//4
console.log(!4);//false
console.log(!!4);//true

/*P16-位运算符*/
//位运算符是对二进制表示的数字进行操作的，把二进制，转换成32位进制数字
//与，或，异或，取反，左移，右移，无符号的右移

console.clear();
// 5 101
// 3 011

console.log('5&3',5&3);//1
console.log('5|3',5|3);//7
console.log('5^3',5^3);//6
console.log('~5',~5);//-6
console.log('~3',~3);//-4

console.log('5 << 1', 5 << 1);//10左移一位
console.log('5 >> 1', 5 >> 1);//2右移一位
console.log('-5 >>> 1', -5 >>> 1);//hbuilder/2.14748e+09，浏览器2147483645无符号右移

/*P17-三目运算符*/
console.clear();
//其实就是简单的条件控制语句，VH大概是?:组成了三元运算符，教程没有说具体哪些是，但使用的时候是的问号和冒号。
//待执行语句也可以是一个三目运算符样式的语句，但是不要这么做，嵌套过多，影响阅读
var temperature = 10;
console.log(temperature > 15 ? '出门' : '在家');
var temperature = 16;
console.log(temperature > 15 ? '出门' : '在家');

