/*P4-简介-开发环境配置*/
//最简单编写JS的方式是使用浏览器的console
//首先打开chrome浏览器，右击空白处，选择‘inspect’中文是‘审查元素’，
//然后在最下面会看到一个console标签，这里就可以输入代码，
//或者找到并点击最上面的一个console标签，整个开发者工具窗口就变成console的输入框
//VH:我平时使用窗口顶部的console标签打开console窗口，没有用这个在窗口下方的console(这里叫console抽屉，区别于窗口顶部的console标签卡，
//VH:有的同学可能没有底部这个，可以Esc键打开关闭这个下方的console)

/*
//输入"hello worlld",记得加上双引号，因为是字符串
"hello world"
"hello world"//返回内容也是带引号的"hello world"

//也可以是数字，数字不用加引号，
5
5//返回内容，也是5

//如果不加引号的字母，会被认为是一个变量，返回一个错误
a
Uncaught ReferenceError: a is not defined at <anonymous>:1:1
//上面是返回信息，意思是引用错误，a没有被定义

//一些简单的数学计算
5+3
//返回值8
//8

//定义一些变量
a = 5
5//返回5
a+3
8//返回8

*/
//像上面这样在console中写代码，只能写简单的代码。
//因为console不能保持代码，所以，我们需要一个代码编辑器
//下面开始安装VScode，全称是Visual Studio Code

//1.打开code.visualstudil.com
//2.找到和自己电脑操作系统对应的版本，windows，mac或者linux
//3.程序下载完成之后，根据不同操作系统，按不同的安装方式安装完成
//4.安装几个扩展，帮助更方便的开发，点击左侧最下的图标，打开扩展侧栏
//5.首先是搜索“live sever”，点击install安装。作用：把html代码运行在服务器上，方便我们使用浏览器访问页面查看运行效果，支持实时刷新，编辑器每保存一次代码就会刷新一次页面
//6.然后是Prettier，作用：格式化代码，支持多种语言JS，TS，HTML，CSS。
//为实现保存时就格式化代码的功能，我们需要对prettier插件进行设置，方法如下
//快捷方式ctrl+shift+P，可以快速执行一些命令，settings:open settings(UI)，打开带用户界面的设置页面，
//搜索formatonsave,确保Editior:Format On Save下方的选项打上对勾。


//7.另外，可以下载FiraCode字体，可以把编程中使用的一些符号，变成和我们印象中的一样
//首先，打开FiraCode的官网，https://github.com/tonsky/FiraCode
//官网介绍：可以把一些符号变成另一种特定的符号，比如不等于(!=)，箭头(=>)，加加(++)等等会有更接近印象中的显示样式
//找到下载链接，下载完成后，在本地找到并安装，安装方式各个系统不一样，可以自行按照合适方法安装。
//快捷方式ctrl+shift+P，打开settings，在Editor:Font Size选项下方的输入框，开头首位置加入Fira Code用逗号隔开
//然后需要把“连体字符”配置项打开，顶部搜索框输入‘font ligature’，不过，这里支持通过setting.json来配置
//点击"edit in settings.json",打开后显示一个大的json对象，我们只需要加入一行
//"editor.fontLigatures":true,
//注意上面的双引号和末尾的逗号【,】,为了安全起见，建议重启一次VScode
//重启完成，新建文件内写入>=,=>（箭头函数符号），==（变成长等号，是判断符），===(变成3条线等号，也是判断符号与前面的2个等于号有区别，后面会讲)

//开发环境已经配置好了。

