/*P8-简介-基本数据类型*/

//boolean,布尔值

var visible = true;//无需引号
var isEqual = false;//无需引号

//console显示的结果也无引号
console.log(visible);//true

//number，数字
//JS中小数和整数都是number类型，后面会讲
var num = 100;//无需引号
var floatingNum = 12.34;//无需引号
var negative = -100;//无需引号

//console显示的结果也无引号
console.log(num);//100
console.log(floatingNum);//12.34
console.log(negative);//-100

//string，字符串
//单引号或双引号
var str = 'hello!';
console.log(str);

//undefined,未定义（未初始化）

var notInitialized;
console.log(notInitialized);//undefined
var notInitialized2= undefined;
console.log(notInitialized2);//undefined

//null，是值的一种
//null已经赋值，值就是null，代表为空，undefined是没有赋值（初始化）

var emptyValue = null;
console.log(emptyValue);//null
console.log('上面是null的值');
console.log(emptyValue+'左边是null的值');//一起拼接显示null

/*
总结：以上等于号后面的都是literals，字面值，不变。把它赋值给变量，就成了变量的值。
后面讲if等可以拿变量和字面值进行比较。
另外，还有array，object，function等特殊数据类型

*/

/*P9-基础-基本数据类型转换 */
//JS是动态数据类型，var即可，不必指定类型

//查看变量数据类型
//typeof()可以查看变量的数据类型
console.log(typeof visible);//boolean
console.log(typeof num);//number
console.log(typeof floatingNum);//number//JS中小数和整数都是Number类型
console.log(typeof str);//string
console.log(typeof notInitialized);//undefined
console.log(typeof emptyValue);//object,早期ECMA规范是这么来的，但是null实际就是基本类型

//变量类型变化
var age=15;
console.log(typeof age);//number

//改变方法：
//1.赋值其他的数据类型，
//2.不同数据类型变量之间的一些操作也会改变数据类型

//方法1：赋值其他的数据类型，
//JS在执行的时候动态判断变量的类型，下面age被重新赋值字符串'15'
//JS判断为string，后续使用时保持为string，直到一些赋值操作让它改变
age='15'
console.log(typeof age);//string

//方法2：不同数据类型变量之间的一些操作

//拼接+操作
//两边数据类型不统一，这里+表示字符串拼接不是加号，
//num变成了string类型，拼接一起100hello!
var result=num+str;
console.log(result);//100hello!,

//sting转数字，
//使用parseInt(),parseFloat()
var strNum='123';
console.log(parseInt(strNum)+100)//223,